<?PHP

require_once("class/PWHash.php");
$PWHash = new PWHash();

if (isset($_SESSION['userid']) && is_numeric($_SESSION['userid']))
{
	if (isset($_GET['logoutsession']) && $_GET['logoutsession'] == "logout")
	{
		logout($sessionName);
		$verifyFailReason = "{webui_logoutsuccess}";
	}
	else
	{
		$resInfo = $class_db->db_query("SELECT adminlevel, userstatus FROM jts3servermodwebui_users WHERE id = ".$_SESSION['userid']);
		if (mysqli_num_rows($resInfo) == 1)
		{
			$userInfo = mysqli_fetch_array($resInfo);
			
			if ($userInfo[1] == -1)
			{
				logout($sessionName);
				$verifyFailReason = "{webui_accountdeactivated}";
			}
			else
			{
				$class_db->db_query("UPDATE jts3servermodwebui_users SET `lastvisit` = '".time()."' WHERE id = ".$_SESSION['userid']);
				if (!isset($_SESSION['adminlevel']) || $_SESSION['adminlevel'] != $userInfo[0]) $_SESSION['adminlevel'] = $userInfo[0];
			}
		}
		else
		{
			logout($sessionName);
			$verifyFailReason = "{webui_wronglogin}";
		}
	}
}
else if (isset($_POST['loginsubmit']))
{
	if (isset($_POST['loginname']) && isset($_POST['loginpassword']))
	{
		$compatibilityMode = false;
		$resInfo = $class_db->db_query("SELECT id, name, password, adminlevel, userstatus, logintrycount, logintrytime, salt, theme FROM jts3servermodwebui_users WHERE name = \"".$class_db->getRealEscapeString($_POST['loginname'])."\" OR email = \"".$class_db->getRealEscapeString($_POST['loginname'])."\"", true);
		if ($resInfo === false)
		{
			$compatibilityMode = true;
			$resInfo = $class_db->db_query("SELECT id, name, password, adminlevel, userstatus, logintrycount, logintrytime, theme FROM jts3servermodwebui_users WHERE name = \"".$class_db->getRealEscapeString($_POST['loginname'])."\" OR email = \"".$class_db->getRealEscapeString($_POST['loginname'])."\"");
		}
		
		if (mysqli_num_rows($resInfo) == 1)
		{
			$userInfo = mysqli_fetch_array($resInfo);

			if ($userInfo[5] > 5 && $userInfo[6] > (time() - (60 * 60 * 24)))
			{
				// More than 5 tries in the last 24 hours
				$verifyFailReason = "{webui_loginspam}";
			}
			else if ($userInfo[4] == -1)
			{
				$verifyFailReason = "{webui_accountdeactivated}";
			}
			else
			{
				if (!$compatibilityMode && strlen($userInfo[2]) > 50 && $userInfo[2] == $PWHash->hashString($_POST['loginpassword'], $userInfo[7]))
				{
					$class_db->db_query("UPDATE jts3servermodwebui_users SET `logintrycount` = '0', `lastvisit` = '".time()."', `resetkey` = '' WHERE id = ".$userInfo[0]);
					$_SESSION['userid'] = $userInfo[0];
					$_SESSION['username'] = $userInfo[1];
					$_SESSION['adminlevel'] = $userInfo[3];
					$_SESSION['theme'] = $userInfo[8];
				}
				else if (strlen($userInfo[2]) < 50 && $userInfo[2] == md5(sha1(sha1($_POST['loginpassword']))))
				{
					if (!$compatibilityMode)
					{
						$pwsalt = $PWHash->createSalt();
						$class_db->db_query("UPDATE jts3servermodwebui_users SET `password` = '".$PWHash->hashString($_POST['loginpassword'], $pwsalt)."', `salt` = '".$pwsalt."', `logintrycount` = '0', `lastvisit` = '".time()."', `resetkey` = '' WHERE id = ".$userInfo[0]);
					}
					$_SESSION['userid'] = $userInfo[0];
					$_SESSION['username'] = $userInfo[1];
					$_SESSION['adminlevel'] = $userInfo[3];
					$_SESSION['theme'] = $userInfo[7];
				}
				else
				{
					$verifyFailReason = "{webui_wronglogin}";
					$class_db->db_query("UPDATE jts3servermodwebui_users SET logintrycount = logintrycount+1, `logintrytime` = '".time()."' WHERE id = ".$userInfo[0]);
				}
			}
		}
		else
		{
			$verifyFailReason = "{webui_wronglogin}";
		}
	}
	else
	{
		$verifyFailReason = "{webui_loginmissing}";
	}
}
?>